varying highp vec2 outCoords, vertPos;

uniform sampler2D texture, ramp;

uniform mediump float distortAmount;

void main()
{
	mediump vec2 v = outCoords * 2.0 - 1.0;
	mediump float d = length(v) * 35.0;
	
	d = min(1.0, (1.0 - min(1.0, d)) * 2.0);

	highp vec4 textureClr = texture2D(texture, vertPos);
	highp float colorVal = textureClr.x;
	highp float colorOffset = floor(colorVal * 14.999999);
	highp vec2 colorCoords = vec2((0.5 + colorOffset * 16.0) * 0.00390625 + textureClr.z * 0.05836575875, textureClr.y);
	
	highp vec3 clr1 = texture2D(ramp, colorCoords).xyz;
	
	colorCoords.x += 0.0625;
	
	highp vec3 clr2 = texture2D(ramp, colorCoords).xyz;
	
	highp float colorPercent = colorVal * 15.0 - colorOffset;
	
	highp vec3 finalClr = mix(clr1, clr2, colorPercent);

	highp float percent = (d * 0.3 + 0.7) * distortAmount;
	
	finalClr = finalClr.zyx * percent + textureClr.xyz * (1.0 - percent);
	
    gl_FragColor = vec4(finalClr, textureClr.w);
}
