attribute vec2 position;
attribute vec2 texcoords;

varying vec2 outCoords, vertPos;

uniform mat3 viewMatrix;
uniform mat2 quadMatrix;
uniform vec2 quadPos;

void main()
{
	vec2 screenPos = (position * 2.0 - 1.0) * quadMatrix + (quadPos * 2.0 - 1.0);
	vec3 viewPos = vec3(screenPos, 1.0) * viewMatrix;
    gl_Position = vec4(viewPos.xy, vec2(0.0, 1.0));

    outCoords = texcoords.yx;
	vertPos = viewPos.xy * 0.5 + 0.5;
}
